package aln.spawncommands;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommand;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.Entity;
import net.minecraft.entity.boss.EntityDragon;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.SoundEvent;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

// public class CommandTeleportAsk implements ICommand { // mc1.8.9
public class CommandOK  extends CommandBase {
  
  public static float responseTimeLimitSeconds;
  public static long  responseTimeLimit;
  public static float requestJustCameInDelaySeconds;
  public static long  requestJustCameInDelay;
  public static float lastPlayerAskedTimeoutHours;
  public static long  lastPlayerAskedTimeout;
  
  private static final String TAConfigBasePath = SpawnCommands.configBasePath+"/_TeleportAsk/";
  public static final String incomingRequestFileName = "_TeleportAsk_IncomingRequest.txt";
  public static final String incomingResponseFileName = "_TeleportAsk_IncomingResponse.txt";
  public static final String lastPlayerAskedFileName = "_TeleportAsk_LastPlayerAsked";
  
  @Override
  public int compareTo(ICommand arg0) {
    return 0;
  }
  
  @Override
  public String getCommandName() {
    return Do.getConfigArrayValue(SpawnCommands.commandNames ,"ok");
  }
  
  @Override
  public String getCommandUsage(ICommandSender sender) { 
    // Apparently this is run EVERY time someone does /help of any kind...
    //return "/ta notch -Asks notch if you may teleport to him. Then telports you to Sweeden.Ya!"; // limited to 82 characters long lol
    return "/"+ Do.getConfigArrayValue(SpawnCommands.commandNames ,"ok") +" help     Displays a page of help";
  }
  
  @Override
  public List getCommandAliases() {
    return Arrays.asList(new String[] { });
  }
  
  @Override
  public void execute(MinecraftServer server, ICommandSender sender, String[] params) throws CommandException { // mc1.9
  //public void execute(                      ICommandSender sender, String[] params) throws CommandException { // mc1.8.9
    if(sender instanceof EntityPlayer) {
      EntityPlayer player = (EntityPlayer) sender;
      String playerName = player.getName(); // mc1.8
      //String playerName = player.getGameProfile().getName(); // mc1.7.10
      World world = player.worldObj;
      if ( world.isRemote ) { return; }
      
      if (params.length > 0) { CommandTeleportAsk.ShowTAHelp(player); return; }
      
      if ( SpawnCommands.isSingleplayer ) { 
        Do.Say(player," ");
        Do.Say(player,"/\u00A7eta\u00A7r  (\u00A7eT\u00A7releport \u00A7eA\u00A7rsk) is a Multiplayer only feature."); 
        Do.Say(player,"Sorry, there is no need for it in single player."); 
        return; 
      }
      
      // command permissions. "no" is handled by not registering the command at all. "op" and "enable" are handled here. "all" is the default.
      SpawnCommands.loadCommandPermissionsConfig();
      if ( Do.getConfigArrayValue(SpawnCommands.commandPermissions, "ta").equalsIgnoreCase("op") && (! Do.IsOp(player)) ) 
      { Do.Say(player,"Op only command.  You are not an op."); return; }
      if ( Do.getConfigArrayValue(SpawnCommands.commandPermissions, "ta").equalsIgnoreCase("enabled") && (! SpawnCommands.advancedCommandsAreEnabled() ) ) 
      { Do.Say(player,"Advanced spawn commands are not enabled."); return; }
      // the above is because this command requires the above /ta command to exist
      // the below is checking permissions for this command /ok
      if ( Do.getConfigArrayValue(SpawnCommands.commandPermissions, "ok").equalsIgnoreCase("op") && (! Do.IsOp(player)) ) 
      { Do.Say(player,"Op only command.  You are not an op."); return; }
      if ( Do.getConfigArrayValue(SpawnCommands.commandPermissions, "ok").equalsIgnoreCase("enabled") && (! SpawnCommands.advancedCommandsAreEnabled() ) ) 
      { Do.Say(player,"Advanced spawn commands are not enabled."); return; }
      
      SpawnCommands.loadMiscConfig();
      responseTimeLimitSeconds = Do.getConfigArrayValueFloat(SpawnCommands.miscConfigArray,"teleportask responseTimeLimitSeconds"); // 45s default
      if (responseTimeLimitSeconds < 10) { responseTimeLimitSeconds = 10; } // minimum 10sec
      responseTimeLimit = (long) (responseTimeLimitSeconds * 1000);
      requestJustCameInDelaySeconds = Do.getConfigArrayValueFloat(SpawnCommands.miscConfigArray,"teleportask requestJustCameInDelaySeconds"); // 1.2s default
      requestJustCameInDelay = (long) (requestJustCameInDelaySeconds * 1000);
      lastPlayerAskedTimeoutHours = Do.getConfigArrayValueFloat(SpawnCommands.miscConfigArray,"teleportask lastPlayerAskedTimeoutHours"); // 16h default
      if (lastPlayerAskedTimeoutHours < (10/60)) { lastPlayerAskedTimeoutHours = 10/60; } // minimum 10min
      lastPlayerAskedTimeout = (long) (lastPlayerAskedTimeoutHours * 1000*60*60);
      
      long timeNow = (new Date()).getTime(); // in milliseconds
      String timeNowString = Long.toString(timeNow);
      
      String filePathAndName;
      MinecraftServer mcServer = ((EntityPlayerMP)player).mcServer;
      
      //  /ok   synonym for /ta ok|accept|yes
      filePathAndName = TAConfigBasePath+playerName+"/"+incomingRequestFileName;
      if (Do.fileExists(filePathAndName)) {
        String[] incomingRequest = Do.FileToString(filePathAndName).split(",");
        if ( incomingRequest.length != 3 ) { Do.Say(player,"You have no pending Teleport Ask request now."); return; } // either there is no request or its an invalid file format
        
        // parse file
        long   requestTime = Long.parseLong(incomingRequest[0]);
        String requestName = incomingRequest[1];
        String requestType = incomingRequest[2]; // type ta
        //EntityPlayer requestPlayer = mcServer.getConfigurationManager().getPlayerByUsername(requestName); // mc1.8 // will be null if they are not in game
        EntityPlayer requestPlayer = Do.getPlayerByUsername(mcServer,requestName); // mc1.7.10 custom function // will be null if they are not in game
        
        // safety time delay if a request comes in while answering a request
        if ( (timeNow - requestTime) < requestJustCameInDelay ) {
          Do.Say(player,"A new teleport request just came in.");
          Do.Say(player,"Did \u00A7enot\u00A7r accept the teleport request from "+requestName+".");
          Do.Say(requestPlayer,"Teleport accept failed.  Try /ta again.");
          return;
        }
        
        if ( requestType.equals("ta") && ((timeNow - requestTime) < responseTimeLimit) ) { // if within time limit
          
          // file the approval
          if (! Do.StringToFile(TAConfigBasePath+requestName+"/"+incomingResponseFileName,""+timeNow+","+playerName+","+"accept") ) 
          { Do.Err(player,"Could not create file "+TAConfigBasePath+requestName+"/"+incomingResponseFileName); return; }
          
          // notify players
          Do.Say(requestPlayer,"Teleport ask has been \u00A72accepted\u00A7r by "+playerName+". ("+responseTimeLimitSeconds+"s)"); // if requestPlayer is null Do.Say does nothing.
          Do.Say(player,"You have \u00A72accepted\u00A7r \u00A7e"+requestName+"\u00A7r asking to teleport to you. ("+responseTimeLimitSeconds+"s)");
          
          // update the default player name for typing just /ta
          Do.StringToFile(TAConfigBasePath+requestName+"/"+lastPlayerAskedFileName,timeNow+","+playerName);
          Do.Say(requestPlayer,"Try /"+Do.getConfigArrayValue(SpawnCommands.commandNames,"ta")+" now.");
          
          return;
        } else { Do.Say(player,"You have no pending Teleport Ask request now"); return; }
        
      } else { Do.Say(player,"You have no pending Teleport Ask request now"); return; } // 2.1.5
      
    } // end if entity player
  }
  
  @Override
  public   boolean checkPermission(MinecraftServer server, ICommandSender sender) { // mc1.9
  //public boolean canCommandSenderUseCommand(             ICommandSender sender) { // mc1.8 mc1.7.10
    return true;
  }
  
  @Override
  public   List<String> getTabCompletionOptions(MinecraftServer server, ICommandSender sender, String[] args, BlockPos pos) { // mc1.9
  //public List         addTabCompletionOptions(                        ICommandSender sender, String[] args, BlockPos pos) { // mc1.8
	//public List         addTabCompletionOptions(                        ICommandSender sender, String[] args) { // mc1.7.10
    //experiment:  // how does this work in singleplayer worlds? will it crash?
    //List<String> list = Arrays.asList(((EntityPlayerMP)sender).mcServer.getConfigurationManager().getAllUsernames()); // mc1.8.9
    List<String> list = Arrays.asList(((EntityPlayerMP)sender).mcServer.getAllUsernames()); // mc1.8.9
    return list;
  }
  
  @Override
  public boolean isUsernameIndex(String[] astring, int i) {
    return false;
  }
  
}
