package aln.spawncommands;

import java.util.Arrays;
import java.util.List;

import net.minecraft.command.ICommand;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.BlockPos;

public class CommandSpawnPoint implements ICommand {
  
  @Override
  public int compareTo(ICommand arg0) {
    return 0;
  }

  @Override
  public String getCommandName() {
    //return "spawn.";
	return Do.getConfigArrayValue(SpawnCommands.commandNames ,"spawn.");
  }

  @Override
  public String getCommandUsage(ICommandSender icommandsender) {
    return "/"+ Do.getConfigArrayValue(SpawnCommands.commandNames ,"spawn.") +" - Teleports you to your bed spawn point if it is set.";
  }

  @Override
  public List getCommandAliases() {
    //return Arrays.asList(new String[] {"home"});
    return Arrays.asList(new String[] { });
  }

  @Override
  public void execute(MinecraftServer server, ICommandSender icommandsender, String[] params) {
    if(icommandsender instanceof EntityPlayer) {
      EntityPlayer player = (EntityPlayer) icommandsender;
      if ( player.worldObj.isRemote ) { return; }
      
      SpawnCommands.loadCommandPermissionsConfig();
      SpawnCommands.loadMiscConfig();
      
      // command permissions. "no" is handled by not registering the command at all. "op" and "enable" are handled here. "all" is the default.
      if ( Do.getConfigArrayValue(SpawnCommands.commandPermissions, "spawn.").equalsIgnoreCase("op") && (! Do.IsOp(player)) ) 
      { Do.Say(player,"Op only command.  You are not an op."); return; }
      if ( Do.getConfigArrayValue(SpawnCommands.commandPermissions, "spawn.").equalsIgnoreCase("enabled") && (! SpawnCommands.advancedCommandsAreEnabled() ) ) 
      { Do.Say(player,"Advanced spawn commands are not enabled."); return; }
      
      if (params.length > 0) { SpawnCommands.showHelp(player); return; }
      SpawnCommands.GoToBedSpawnPoint(player);
    } // end of is player
  }

  @Override
  public boolean checkPermission(MinecraftServer server, ICommandSender icommandsender) { // mc1.8
  //public boolean canCommandSenderUseCommand(ICommandSender icommandsender) { // mc1.7.10
    return true;
  }
  
  @Override
  public List getTabCompletionOptions(MinecraftServer server, ICommandSender sender, String[] args, BlockPos pos) { // mc1.8
  //public List addTabCompletionOptions(ICommandSender icommandsender, String[] astring) { // mc1.7.10
    return null;
  }
  
  @Override
  public boolean isUsernameIndex(String[] astring, int i) {
    return false;
  }
  
}
